/* sorgente: memcpy.c */

/* illustra il corretto utilizzo dalla funzione memcpy() */

/* inclusione del file di intestazione della libreria standard
** che contiene definizioni di macro, costanti e dichiarazioni
** di funzioni e tipi funzionali alle varie operazioni di I/O */

#include <stdio.h>

/* inclusione del file di intestazione della libreria
** standard che contiene definizioni di macro,
** costanti e dichiarazioni di funzioni di interesse generale,
** e per la gestione della memoria e delle stringhe */

#include <stdlib.h>
#include <string.h>

/*
** funzione che inizializza il contenuto di un buffer
** con una sequenza progressiva di interi
*/
void InBuffInt(int *ptr, unsigned int dim)
  {
  /* definisce il cursore per la scansione del buffer */
  int curs;
  
  /* scandisce il buffer inizializzandone il contenuto */
  for (curs = 0; curs <= dim-1; curs++)
    ptr[curs] = curs;
  }
  
/*
** funzione che visualizza il contenuto di un buffer di interi
*/
void VisBuffInt(int *ptr, unsigned int dim)
  {
  /* definisce il cursore per la scansione del buffer */
  int curs;
  
  /* scandisce il buffer visualizzandone il contenuto */
  for (curs = 0; curs <= dim-1; curs++)
    printf("\n Elemento %d: %d", curs, ptr[curs]);
  }
  
/*
** alloca due buffer di interi, inizializza il I e lo visualizza,
** lo copia nel II e poi ne visualizza il contenuto. Infine rilascia
** la memoria allocata per entrambi i buffer
*/
int main()
  {
  /* definisce le variabili per la dimensione dei buffer,
  ** espressa in numero di interi, e per i loro indirizzi
  ** di inizio */
  unsigned int nro_val;
  int *ptr_1, *ptr_2;
  
  /* acquisisce la dimensione dei buffer */
  printf("\nQuanti valori nei buffer? ");
  scanf("%u", &nro_val);
  
  /* alloca i due buffer */
  ptr_1 = (int *) calloc(nro_val, sizeof(int));
  ptr_2 = (int *) calloc(nro_val, sizeof(int));
  
  /* controlla se lallocazione ha successo */
  if ((ptr_1 == NULL) || (ptr_2 == NULL))
    {
    /* se fallisce rilascia la memoria eventualmente allocata
	** e termina */
    printf("\nAllocazione fallita");
    
    if (ptr_1 != NULL)
      free(ptr_1);
      
    if (ptr_2 != NULL)
      free(ptr_2);
      
    return(0);
    };
    
  /* altrimenti inizializza il I buffer e lo visualizza */
  printf("\nAllocazione avvenuta con successo\n");
  InBuffInt(ptr_1, nro_val);
  printf("\nContenuto I Buffer:");
  VisBuffInt(ptr_1, nro_val);
    
  /* copia il I buffer nel II e lo visualizza */
  /* memcpy(ptr_2, ptr_1, nro_val*sizeof(int)); */
  printf("\nContenuto II Buffer:");
  VisBuffInt(memcpy(ptr_2, ptr_1, nro_val*sizeof(int)), nro_val);
    
  /* rilascia la memoria per entrambe i buffer */
  free(ptr_1);
  free(ptr_2);
  
  return(1);
  }
